/* program na ovladani vice rele (zde zadano MAX 255)s pouzitim Neopixel RGB led diod WS2812B 
   nebo WS2811, pri pouziti WS2811 se MUSI ZMENIT HODNOTA NEO_KHZ800 ZA HODNOTU NEO_KHZ400.
   Zadavani cisla ovladane RGB didy a hodnot R, G, B, je mozny z PC pomoci prevodniku
   USB/COM TTL s CH340 a seriovym terminalem, nebo z tabletu pomoci bluetooth JDY-33 a 
   seriovym terminalem pro ANDROID. 
   Po odladeni programu je mozne prikazy BT.print pro odesilani dat do PC
   nebo tabletu smazat.
   www.mojeelektronika.mzf.cz
   vagnervlastimil@seznam.cz
*/

#include <Adafruit_NeoPixel.h>
Adafruit_NeoPixel LED = Adafruit_NeoPixel(255, 3, NEO_GRB + NEO_KHZ800);  // max pocet LED, pin pro vystup, rezim
#include <SoftwareSerial.h>                            //prihrani knihovny pro komunikaci 
SoftwareSerial BT=SoftwareSerial(10,11);               // RXD=10 TXD=11 KOMUNIKACNI PINY na ARDUINU 
byte R,G,B;                                            //promenne 
int dioda,poradi;                                      //promenne
 
void setup() {                                         // zacatek hlavni smycky                              
pinMode(3,OUTPUT);                                     // pin pro ovladani RGB LED v pasku
BT.begin(9600);                                        // komunikacni rychlost
LED.begin();                                           // inicializace komunikace s Neopixel
LED.show();                                            // povel pro prenos dat do led
}

void loop(){                                           // hlavni smycka programu
if (BT.available() > 0){                               // nacteni hodnoty pokud je odeslana z terminalu PC nebo tabletu
dioda = BT.parseInt();                                 // prvni hodnota je poradi LED
R = BT.parseInt();                                     // druha hodnota je cislo pro intensitu jasu cervene diody
G = BT.parseInt();                                     // treti hodnota je cislo pro intensitu jasu zelene diody
B = BT.parseInt();                                     // ctvrta hodnota je cislo pro intensitu jasu modre diody
poradi = (dioda - 1);                                  // prepocet na pozadovanou RGB LED diodu Neopixel
for (int i = poradi; i < dioda; i++){                  // opakovani pro cely pasek led
LED.setPixelColor(i,R,G,B);}                           // prikaz pro rozsviceni barev diody
LED.show();                                            // prikaz pro prenos hodnot z pameti LED diody do cipu
BT.print("prijate hodnoty");                           // zobrazeni prijatych hodnot na monitoru PC nebo tabletu
BT.print(dioda);                                       // zobrazeni hodnoty navolene diody
BT.print(R);                                           // zobrazeni hodnoty pro cervenou barvu
BT.print(G);                                           // zobrazeni hodnoty pro zelenou barvu
BT.println(B);                                         // zobrazeni hodnoty pro modrou barvu
dioda=0;                                               // do promenne "dioda" se ulozi hodnota "0"
poradi=0;                                              // do promenne "poradi" se ulozi hodnota "0"
delay(500);                                            // casova prodleva
 }                                                     // konec smycky if BT.available
}                                                      // konec hlavni smycky
